%to evaluate glucose uptake for the circuit with the passed parameter vector
function [ match_criterion ] = eval_ins_obj_normal_plos( log_para_vector )

global ins_pNames


para_vector=10.^log_para_vector;
% simulate the mex insulin model with the passed parameter vector
eval_simoptions.reltol=1e-7;
eval_simoptions.abstol=1e-7;
eval_simres=SBPDsimulate('mex_insmodel',60,mex_insmodel,ins_pNames,para_vector,eval_simoptions);
GLUT4MEMdata_eval = eval_simres.statevalues(:, 20);

%we require that at the last time point the glucose concentration has
%fallen below the half-maximal value
maxglut=max(GLUT4MEMdata_eval);
lastglut=GLUT4MEMdata_eval(end);
if(lastglut>=(maxglut/2))
   match_criterion  =  0;
   return;
end

%compute glucose uptake
GLUT4MEMpoly_eval=pchip(eval_simres.time, GLUT4MEMdata_eval);
GLUT4mem_extrap_eval = @(t) ppval(GLUT4MEMpoly_eval,t);
match_criterion=quad(GLUT4mem_extrap_eval, 0, 60);

match_criterion = -match_criterion;
end

