


%the program reads the output file generated by routines  
%ins_sampling_bruteforce*.m
load('[enter your input file here]');

OUTFILE=strcat('mut_sens_plos_', date,'.mat');

frac_change=1.1;
fprintf('perturbing parameters for sensitivity analysis by a factor %E', frac_change);

%number of mutations to be tried for each parameter
nmut=100;

RandStream.setGlobalStream(RandStream('mt19937ar','seed', 23032014));



lendatnorm=length(outputVolint_normal.V(:,1));
n_params=length(outputVolint_normal.V(1,:));

%now generate a random subset of data of length nsample
samplesize=1000;
sampledat_norm=outputVolint_normal.V(randperm(lendatnorm, samplesize), :);

insmodel=SBmodel('ins_aw_v5_nM_plos.txt');
[ins_pNames, ins_pValuesOriginal] = SBparameters(insmodel);
ins_pNames=transpose(ins_pNames);
ins_pValuesOriginal=transpose(ins_pValuesOriginal);
SBPDmakeMEXmodel(insmodel,'mex_tmp_mod',0);
simoptions.reltol=1e-7;
simoptions.abstol=1e-7;
%simulate the model with the original parameters
%and compute glucose uptake output at the disease threshold
simres_original=SBPDsimulate('mex_tmp_mod',60,mex_tmp_mod,ins_pNames,ins_pValuesOriginal,simoptions);
GLUT4MEMdata_original = simres_original.statevalues(:, 20);
GLUT4MEMpoly=pchip(simres_original.time, GLUT4MEMdata_original);
GLUT4mem_extrap_above_disease = @(t) ppval(GLUT4MEMpoly,t)*0.29*1.48;
tot_uptake_disease=quad(GLUT4mem_extrap_above_disease, 0, 60);

%The following sets the minmal and maximal boundaries for the 
%parameters 
pmin(1:n_params)=1e-3;
pmax(1:n_params)=1e3;
logpmin=log10(pmin);
logpmax=log10(pmax);
 
 %the elements i, j of this matrix will hold, for the i-th parameter set
 % and the j-th parameter the fraction of inviable mutations 
 frac_mut_viable=zeros(samplesize, n_params);
 %the elements i, j of this matrix will hold, for the i-th parameter set
 %and the j-th parameter the sensitivity coefficient
 sens_coeff=zeros(samplesize, n_params);
 
% A BLOCK TO CREATE THE DATA ON SENSITIVITY AND MUTATIONAL ROBUSTNESS
for i=1:samplesize
    logmasterparam=sampledat_norm(i,:);
    
    %to monitor progress
    fprintf('\nanalyzing parameter vector %d', i);
    
    %call the function that evaluates sensitivity coefficients for all parameters
    sens_coeff(i, :) = sensitivity_plos( frac_change, logmasterparam, logpmax, logpmin );
    
    %now compute the fraction of deleterious mutations
    for j=1:n_params
        logparam=logmasterparam;
        for k=1:nmut   
            logparam(j)=logpmin(j)+rand*(logpmax(j)-logpmin(j));
            param=10.^logparam;
            
            simres_mut=SBPDsimulate('mex_tmp_mod',60,mex_tmp_mod,ins_pNames,param,simoptions);
            GLUT4MEMdata_mut = simres_mut.statevalues(:, 20);
            GLUT4MEMpoly=pchip(simres_mut.time, GLUT4MEMdata_mut);
            GLUT4mem_extrap = @(t) ppval(GLUT4MEMpoly,t);
            tot_uptake=quad(GLUT4mem_extrap, 0, 60);
            if (tot_uptake<tot_uptake_disease)
                %this computes the fraction of deleterious mutations 
                frac_mut_viable(i,j)=frac_mut_viable(i,j)+1;              
            %don't forget to reset the parameter vector before the next (round) of mutations  
            logparam=logmasterparam;
            end                    
        end            
        frac_mut_viable(i,j)=frac_mut_viable(i,j)/nmut;
    end
   %save results after each parameter set
   save(OUTFILE);    
end

 
