function [ pop, pheno ] = pop_init_v0( popsize, init_log_para , logpmax, logpmin, thresh_normal)
% to be called from pop_drift_sim
% starts from a viable parameter point and expands it into a population of viable
% points. The returned array pop has
% dimension popsize*(n_params), and each of its rows contains one 
% viable point, pheno(i) contains the phenotype of the i-th individual

%global declaration is important here, because ins_pNames needs to be
% used in the evaluation function below
global ins_pNames;

% now test whether the passed parameter point is actually viable
% also note that the evaluation routine returns the NEGATIVE value of the 
%integrated glut4 concentration, so the minus sign below converts 
%it again to a positive value
init_glut4mut = - eval_ins_obj_normal_v2( init_log_para );
if(init_glut4mut < thresh_normal)
   fprintf('\nerror in create_pop_v0: passed inviable parameter point with glut4 integral: %E', init_glut4mut); 
end

nparams=length(init_log_para);
pop=zeros(popsize, nparams);
pheno=zeros(popsize, 1);
if(popsize<2)
    fprintf('\nerror in pop_init_v0: popsize %E too small', popsize);
    exit;
end

for i=1:popsize
   pop(i, :)=init_log_para;
   pheno(i)=init_glut4mut;  
end
    

end