function [newpop, newpheno]=pop_mutsel_v0(oldpop, oldpheno, logpmax, logpmin, thresh_normal) 

% mutates one parameter in each individual of a passed population and
% computes the phenotype, then samples with replacement from the
% old population to fill a population of the same size, but where everybody
% is viable

global ins_pNames;

popsize=length(oldpheno);

if(popsize<2)
    fprintf('\nerror in create_pop_v0: popsize %E too small', popsize);
    exit;
end
  
nparams=length(oldpop(1,:));
%population after mutation
mutpop=zeros(popsize, nparams);
mutpheno=zeros(popsize, 1);
%final population after mutation and selection
newpop=zeros(popsize, nparams);
newpheno=zeros(popsize, 1);
for i=1:popsize
    mutlogparam=oldpop(i,:);
    mutindex=randi([1 nparams]);
    mutlogparam(mutindex)=logpmin(mutindex)+rand*(logpmax(mutindex)-logpmin(mutindex));
    mutpop(i,:)=mutlogparam;
    
  
    glut4mut = - eval_ins_obj_normal_plos( mutlogparam );
    mutpheno(i) = glut4mut;
end

%now sample only those individuals from the population where the phenotype
%is above the passed threshold
trialctr=1;
for i=1:popsize
  index=randi([1 popsize]);
  trialctr=trialctr+1;
  while(mutpheno(index)<thresh_normal)
      index=randi([1 popsize]);
      trialctr=trialctr+1;
      if(trialctr>100*popsize)
        fprintf('\nerror in popmutsel_v0: too few viables for effective sampling');
      end
  end
  newpop(i,:)=mutpop(index,:);
  newpheno(i)=mutpheno(index);
end




end
